//+------------------------------------------------------------------+
//|                                                   CExcursion.mqh |
//+------------------------------------------------------------------+
#property version   "1.00"
struct SExcursion
  {
      string            symbol;
      double            favourable[],adverse[];
      int               positions;
      double            maxima,minima;
      datetime          timestamp,opentime;
      ENUM_TIMEFRAMES   timeframe;
      
                        SExcursion(){symbol=Symbol();ArrayFree(favourable);ArrayFree(adverse);positions=0;maxima=-1.0*DBL_MAX;minima=DBL_MAX;timestamp=TimeGMT();opentime=TimeGMT();timeframe=Period();};
                        ~SExcursion(){};
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CExcursion
  {
private:

public:
                        CExcursion();
                        virtual void   Get(SExcursion &Excursion[],int Index=0,double Volume=0.0);
                       ~CExcursion();
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CExcursion::CExcursion()
  {
  }
void CExcursion::Get(SExcursion &Excursion[],int Index=0,double Volume=0.0)
   {
      if(ArraySize(Excursion)<0){printf(__FUNCSIG__+" invalid array size  ");return;}
   
      //NEW BAR
      if(TimeGMT()>=Excursion[Index].timestamp){
         Excursion[Index].timestamp=TimeGMT()+(int)(PeriodSeconds(Excursion[Index].timeframe)-MathMod(TimeGMT(),PeriodSeconds(Excursion[Index].timeframe)));
      
      //AE & FE CALCULATIONS
      if(PositionSelect(Excursion[Index].symbol)){
         MqlRates _rates[];ArraySetAsSeries(_rates,true);
         if(CopyRates(Excursion[Index].symbol,Excursion[Index].timeframe,0,2,_rates)>=2){
            ArraySetAsSeries(_rates,true);
            if((datetime)PositionGetInteger(POSITION_TIME)!=Excursion[Index].opentime){
               Excursion[Index].positions++;
               ArrayResize(Excursion[Index].adverse,Excursion[Index].positions);
               ArrayResize(Excursion[Index].favourable,Excursion[Index].positions);
               Excursion[Index].maxima=-1.0*DBL_MAX;
               Excursion[Index].minima=DBL_MAX;}
            if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY){
               if(Excursion[Index].minima>_rates[1].low&&PositionGetDouble(POSITION_PRICE_OPEN)>_rates[1].low){
                  Excursion[Index].minima=_rates[1].low;
                  Excursion[Index].adverse[Excursion[Index].positions-1]=MathAbs(PositionGetDouble(POSITION_PRICE_OPEN)-Excursion[Index].minima)*(Volume==0.0?1.0:Volume*SymbolInfoDouble(Excursion[Index].symbol,SYMBOL_TRADE_TICK_VALUE)*(SymbolInfoDouble(Excursion[Index].symbol,SYMBOL_TRADE_TICK_SIZE)/SymbolInfoDouble(Excursion[Index].symbol,SYMBOL_POINT)));}
               if(Excursion[Index].maxima<_rates[1].high&&PositionGetDouble(POSITION_PRICE_OPEN)<_rates[1].high){
                  Excursion[Index].maxima=_rates[1].high;
                  Excursion[Index].favourable[Excursion[Index].positions-1]=MathAbs(_rates[1].high-PositionGetDouble(POSITION_PRICE_OPEN))*(Volume==0.0?1.0:Volume*SymbolInfoDouble(Excursion[Index].symbol,SYMBOL_TRADE_TICK_VALUE)*(SymbolInfoDouble(Excursion[Index].symbol,SYMBOL_TRADE_TICK_SIZE)/SymbolInfoDouble(Excursion[Index].symbol,SYMBOL_POINT)));}}
            else if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL){
               if(Excursion[Index].maxima<_rates[1].high&&PositionGetDouble(POSITION_PRICE_OPEN)<_rates[1].high){
                  Excursion[Index].maxima=_rates[1].high;
                  Excursion[Index].adverse[Excursion[Index].positions-1]=MathAbs(Excursion[Index].maxima-PositionGetDouble(POSITION_PRICE_OPEN))*(Volume==0.0?1.0:Volume*SymbolInfoDouble(Excursion[Index].symbol,SYMBOL_TRADE_TICK_VALUE)*(SymbolInfoDouble(Excursion[Index].symbol,SYMBOL_TRADE_TICK_SIZE)/SymbolInfoDouble(Excursion[Index].symbol,SYMBOL_POINT)));}
               if(Excursion[Index].minima>_rates[1].low&&PositionGetDouble(POSITION_PRICE_OPEN)>_rates[1].low){
                  Excursion[Index].minima=_rates[1].low;
                  Excursion[Index].favourable[Excursion[Index].positions-1]=MathAbs(PositionGetDouble(POSITION_PRICE_OPEN)-Excursion[Index].minima)*(Volume==0.0?1.0:Volume*SymbolInfoDouble(Excursion[Index].symbol,SYMBOL_TRADE_TICK_VALUE)*(SymbolInfoDouble(Excursion[Index].symbol,SYMBOL_TRADE_TICK_SIZE)/SymbolInfoDouble(Excursion[Index].symbol,SYMBOL_POINT)));}}}}}
   }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CExcursion::~CExcursion()
  {
  }
//+------------------------------------------------------------------+
